# Copyright (c) 2000-2008, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_with tests

%define gcj_support %{?_with_gcj_support:1}%{!?_with_gcj_support:%{?_without_gcj_support:0}%{!?_without_gcj_support:%{?_gcj_support:%{_gcj_support}}%{!?_gcj_support:0}}}

%define jmx_version     1.2.1
%define bootstrap %{?_with_bootstrap:1}%{!?_with_bootstrap:%{?_without_bootstrap:0}%{!?_without_bootstrap:%{?_bootstrap:%{_bootstrap}}%{!?_bootstrap:0}}}

%define section     free

Name:           mx4j
Epoch:		1
Version:        3.0.1
Release:        9.3.4%{?dist}
Summary:        Open source implementation of JMX Java API
License:        ASL 1.1
Group:          Development/Libraries/Java
URL:            http://mx4j.sourceforge.net/
Source0:        %{name}-%{version}-src.tar.gz
Source1:        %{name}-build.policy
Source2:        CatalogManager.properties
Patch0:         mx4j-javaxssl.patch
Patch1:         mx4j-%{version}.patch
Patch2:         mx4j-build.patch
Patch3:         mx4j-docbook.patch
Patch4:         mx4j-no-poa.patch
Patch5:         mx4j-caucho-build.patch
Patch6:         mx4j-no-iiop.patch
Patch7:         mx4j-split-tools.patch
BuildRequires:  jpackage-utils > 0:1.6
BuildRequires:  ant >= 0:1.6
BuildRequires:  ant-trax
%if ! %{bootstrap}
BuildRequires:  ant-apache-resolver
BuildRequires:  jaf
BuildRequires:  servletapi5
BuildRequires:  javamail >= 0:1.2-5jpp
BuildRequires:  xjavadoc
BuildRequires:  xdoclet
BuildRequires:  wsdl4j
BuildRequires:  jakarta-commons-discovery
%endif
BuildRequires:  bcel >= 0:5.2
BuildRequires:  log4j >= 0:1.2.7
BuildRequires:  jakarta-commons-logging >= 0:1.0.1
#BuildRequires:  jetty5
BuildRequires:  xml-commons-apis
BuildRequires:  jsse >= 0:1.0.2-6jpp
BuildRequires:  jce >= 0:1.2.2
BuildRequires:  coreutils
BuildRequires:  docbook-dtds >= 0:1.0
BuildRequires:  docbook-style-xsl >= 0:1.61
BuildRequires:  xml-commons-resolver
BuildRequires:  xml-commons
BuildRequires:  xerces-j2
%if %with tests
BuildRequires:  ant-junit
BuildRequires:  junit >= 0:3.7.1
BuildRequires:  xmlunit
%endif
%if ! %{gcj_support}
Buildarch:      noarch
%endif
Requires(pre):  coreutils
Requires(post): %{_sbindir}/update-alternatives
Requires(postun): %{_sbindir}/update-alternatives
%if ! %{bootstrap}
Requires:	    jaf
#Optional:	    javamail >= 0:1.2-5jpp
%endif
Requires:       log4j >= 0:1.2.7
Requires:       jakarta-commons-logging >= 0:1.0.1
Requires:       xml-commons-apis >= 0:1.3.04
Requires:       bcel >= 0:5.2-8.1
Requires:       jsse >= 0:1.0.2-6jpp
Requires:       jce >= 0:1.2.2
Requires:       xml-commons-resolver12 >= 0:1.3.04
Requires:       xml-commons >= 0:1.3.04
Buildroot:      %{_tmppath}/%{name}-%{version}-%{release}-root
Obsoletes:      openjmx
Provides:       jmxri = 0:%{jmx_version}

%if %{gcj_support}
BuildRequires:          java-gcj-compat-devel
%endif

%description
OpenJMX is an open source implementation of the
Java(TM) Management Extensions (JMX).

%if ! %{bootstrap}
%package tools-extra
Group:          Development/Libraries/Java
Summary:        Additional protocols and scripting for %{name}
BuildRequires:  jython >= 2.1
BuildRequires:  axis >= 0:1.1
BuildRequires:  burlap >= 3.0.8
BuildRequires:  caucho-services
BuildRequires:  hessian >= 3.0.8
Requires:       jython >= 2.1
Requires:       axis >= 0:1.1
Requires:       burlap >= 3.0.8
Requires:       caucho-services
Requires:       hessian >= 3.0.8

%description    tools-extra
%{summary}.
%endif

%if ! %{bootstrap}
%package javadoc
Group:          Development/Documentation
Summary:        Javadoc for %{name}
Obsoletes:      openjmx-javadoc

%description javadoc
%{summary}.
%endif

%if ! %{bootstrap}
%package manual
Group:          Development/Documentation
Summary:        Documentation for %{name}

%description    manual
%{summary}.
%endif

%prep
%setup -q

# FIXME To enable iiop when rmic becomes available for GCJ
# turn off patch6 and turn on patch4
# Patch4 is a backport of upstream changes (MX4J) and may go
# away on future releases
%patch0 -p1 -b .sav0
%patch1 -p0 -b .sav1
%patch2 -b .sav2
%patch3 -p1 -b .sav3
%if ! %{gcj_support}
%patch4 -p0 -b .sav4
%else
%patch5 -p1 -b .sav5
%patch6 -p1 -b .sav6
%endif
%patch7 -p0

cp %{SOURCE1} build
cp %{_sourcedir}/CatalogManager.properties %{_builddir}/%{name}-%{version}/build/
# use the one from docbook-dtds instead of getting it from the net
catalogfile=`xmlcatalog /usr/share/sgml/docbook/xmlcatalog "-//OASIS//DTD DocBook XML V4.1.2//EN"`
sed -i -e s:"http\://www.oasis-open.org/docbook/xml/4.1.2/docbookx.dtd":$catalogfile: src/docs/index.xml
catalogfile=`xmlcatalog /etc/xml/catalog "http://docbook.sourceforge.net/release/xsl/current/html/chunk.xsl" |sed -e s:"file\://"::`
sed -i -e s:"http\://docbook.sourceforge.net/release/xsl/current/html/chunk.xsl":"$catalogfile": src/docs/xsl/mx4j-chunk.xsl

pushd lib
%if %with tests
   ln -sf $(build-classpath junit) .
   ln -sf $(build-classpath xmlunit) .
%endif
   ln -sf $(build-classpath xml-commons-apis) xml-apis.jar
   ln -sf $(build-classpath xerces-j2) xercesImpl.jar
   ln -sf $(build-classpath xalan-j2) xalan.jar
   ln -sf $(build-classpath commons-logging) .
   ln -sf $(build-classpath log4j) .
%if ! %{bootstrap}
   ln -sf $(build-classpath burlap) .
   ln -sf $(build-classpath caucho-services) .
   ln -sf $(build-classpath hessian) .
   ln -sf $(build-classpath axis/axis) .
   ln -sf $(build-classpath axis/jaxrpc) .
   ln -sf $(build-classpath axis/saaj) .
   ln -sf $(build-classpath wsdl4j) .
   ln -sf $(build-classpath jython) .
   ln -sf $(build-classpath xdoclet/xdoclet) .
   ln -sf $(build-classpath xdoclet/xdoclet-jmx-module) .
   ln -sf $(build-classpath xdoclet/xdoclet-mx4j-module) .
   ln -sf $(build-classpath javamail/mailapi) .
   ln -sf $(build-classpath javamail/smtp) .
   ln -sf $(build-classpath jaf) .
   ln -sf $(build-classpath commons-discovery) .
#   ln -sf $(build-classpath jetty5/jetty5) org.mortbay.jetty.jar
%endif
   ln -sf $(build-classpath bcel) .
   ln -sf $(build-classpath servletapi5) servlet.jar
   ln -sf $(build-classpath jsse) .
   ln -sf $(build-classpath jsse/jcert) jcert.jar
   ln -sf $(build-classpath jsse/jnet) jnet.jar
   ln -sf $(build-classpath jaas) .
   ln -sf $(build-classpath xml-commons-resolver) .
popd

%build
export OPT_JAR_LIST="ant/ant-junit junit xmlunit ant/ant-trax jaxp_transform_impl xalan-j2-serializer ant/ant-apache-resolver xml-commons-resolver"

cd build
%if ! %{bootstrap}
%if %with tests
ant -Dbuild.sysclasspath=first compile.jmx compile.rjmx compile.tools tests-report javadocs docs
%else
ant -Dbuild.sysclasspath=first compile.jmx compile.rjmx compile.tools javadocs docs
%endif
%else
ant -Dbuild.sysclasspath=first compile.jmx compile.rjmx
%endif

%install
rm -rf $RPM_BUILD_ROOT

install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}
install -m 644 dist/lib/%{name}-impl.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-impl-%{version}.jar
install -m 644 dist/lib/%{name}-jmx.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-jmx-%{version}.jar
install -m 644 dist/lib/%{name}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-%{version}.jar
%if ! %{bootstrap}
install -m 644 dist/lib/%{name}-tools.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-tools-%{version}.jar
install -m 644 dist/lib/%{name}-tools-extra.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-tools-extra-%{version}.jar
%endif
install -m 644 dist/lib/%{name}-rjmx.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-rjmx-%{version}.jar
install -m 644 dist/lib/%{name}-rimpl.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-rimpl-%{version}.jar
install -m 644 dist/lib/%{name}-remote.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-remote-%{version}.jar
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}/boa
install -m 644 dist/lib/boa/%{name}-rjmx-boa.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/boa/%{name}-rjmx-boa-%{version}.jar
install -m 644 dist/lib/boa/%{name}-rimpl-boa.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/boa/%{name}-rimpl-boa-%{version}.jar
install -m 644 dist/lib/boa/%{name}-remote-boa.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/boa/%{name}-remote-boa-%{version}.jar

pushd $RPM_BUILD_ROOT%{_javadir}/%{name}
   for jar in *-%{version}.jar ; do
      ln -fs ${jar} $(echo $jar | sed "s|-%{version}.jar|.jar|g")
   done
popd

%if ! %{bootstrap}
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -r dist/docs/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}
%endif

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%pre
%{__rm} -f %{_javadir}/%{name}.jar

%post
%{_sbindir}/update-alternatives --install %{_javadir}/jmxri.jar jmxri %{_javadir}/%{name}/%{name}-jmx.jar 0

%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%postun
if [ "$1" = "0" ]; then
      %{_sbindir}/update-alternatives --remove jmxri %{_javadir}/%{name}/%{name}-jmx.jar
fi

%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(0644,root,root,0755)
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/%{name}-%{version}.jar
%{_javadir}/%{name}/%{name}.jar
%{_javadir}/%{name}/%{name}-impl-%{version}.jar
%{_javadir}/%{name}/%{name}-impl.jar
%{_javadir}/%{name}/%{name}-jmx-%{version}.jar
%{_javadir}/%{name}/%{name}-jmx.jar
%{_javadir}/%{name}/%{name}-remote-%{version}.jar
%{_javadir}/%{name}/%{name}-remote.jar
%{_javadir}/%{name}/%{name}-rimpl-%{version}.jar
%{_javadir}/%{name}/%{name}-rimpl.jar
%{_javadir}/%{name}/%{name}-rjmx-%{version}.jar
%{_javadir}/%{name}/%{name}-rjmx.jar
%if ! %{bootstrap}
%{_javadir}/%{name}/%{name}-tools-%{version}.jar
%{_javadir}/%{name}/%{name}-tools.jar
%endif
%dir %{_javadir}/%{name}/boa
%{_javadir}/%{name}/boa/*.jar
%if %{gcj_support}
%dir %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/mx4j-%{version}.jar.*
%attr(-,root,root) %{_libdir}/gcj/%{name}/mx4j-tools-%{version}.jar.*
%attr(-,root,root) %{_libdir}/gcj/%{name}/mx4j-remote-boa-%{version}.jar.*
%endif

%if ! %{bootstrap}
%files tools-extra
%defattr(-,root,root)
%{_javadir}/%{name}/%{name}-tools-extra-%{version}.jar
%{_javadir}/%{name}/%{name}-tools-extra.jar
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/mx4j-tools-extra-3.0.1.jar.*
%endif
%endif

%if ! %{bootstrap}
%files javadoc
%defattr(-,root,root)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}
%endif

%if ! %{bootstrap}
%files manual
%defattr(0644,root,root,0755)
%doc dist/docs/*
%endif

%changelog
* Thu Mar 31 2011 Permaine Cheung <pcheung@redhat.com> - 1:3.0.1-9.3.4
- Fix R: bcel to 5.2-8.1

* Thu Mar 10 2011 Permaine Cheung <pcheung@redhat.com> - 1:3.0.1-9.3.3
- Fix R: xml-commons-resolver

* Thu Mar 10 2011 Permaine Cheung <pcheung@redhat.com> - 1:3.0.1-9.3.2
- Add version to the R: xml-commons and subpackages

* Fri May 07 2010 Martha Benitez <mbenitez@redhat.com> - 1:3.0.1-9.3.1
- rebuilt

* Mon Apr 19 2010 Yiqiao Wang <yiwang@redhat.com> 0:3.0.1-9.3
- Rebuild
- Disable tests

* Tue Apr 06 2010 Hui Wang <huwang@redhat.com> 0:3.0.1-9.2
- Rebuild


* Thu Jan 08 2009 Permaine Cheung <pcheung@redhat.com> 0:3.0.1-9.1
- Merge with upstream
- Make javamail optional
- Disable jetty5

* Fri Oct 24 2008 David Walluck <dwalluck@redhat.com> 0:3.0.1-9
- License is ASL 1.1

* Wed Jul 23 2008 David Walluck <dwalluck@redhat.com> 0:3.0.1-8
- remove javadoc scriptlets
- GCJ fixes
- fix file ownership
- update License
- update BuildRoot
- remove Vendor and Distribution
- use macros
- add xalan-j2-serializer to OPT_JAR_LIST

* Mon Mar 05 2007 Fernando Nasser <fnasser@redhat.com> 0:3.0.1-3jpp.el4ep1.1
- Add missing build dependency on ant-junit
- Add missing build dependency on servletapi5
- Make javamail optional

* Tue Feb 13 2007 Ralph Apel <r.apel at r-apel.de> 0:3.0.1-7jpp
- Add bootstrap option: omit tools
- Split out tools-extra subpackage, split mx4j-tools.jar
- Reactivated jetty

* Fri Aug 25 2006 Deepak Bhole <dbhole@redhat.com> 0:3.0.1-6jpp
- Make tests conditional
- Fixed build file to correctly resolve dtds.

* Mon Jul 24 2006 Fernando Nasser <fnasser@redhat.com> 0:3.0.1-5jpp
From Thomas Fitzsimmons <fitzsim@redhat.com>:
- Require xerces-j2

* Tue Jul 18 2006 Fernando Nasser <fnasser@redhat.com> 0:3.0.1-4jpp
- Remove duplicate macros
- Use unversioned burlap and hessian
- Don't use jetty4 as it is not yet available on JPP 1.7
- Re-add Epoch to the versions required
- Split patch for removal of poa
- Add AOT bits

* Wed Mar 15 2006 Fernando Nasser <fnasser@redhat.com> 0:3.0.1-3jpp_2rh
- Change dependencies from hessian3 and burlap3 to just hessian and burlap

* Wed Mar 15 2006 Fernando Nasser <fnasser@redhat.com> 0:3.0.1-3jpp_1rh
- Merge with upstream

* Tue Mar 14 2006 Fernando Nasser <fnasser@redhat.com> 0:3.0.1-3jpp
- Remove dependencies on non-free JXM packages by building MX4J's own
- Add (re-add?) "java.naming.corba.orb" patch, needed by JOnAS

* Fri Mar 10 2006 Ralph Apel <r.apel@r-apel.de> 0:3.0.1-2jpp
- Activate burlap and hessian support
- Most unit tests now pass with java-1.4.2-sun-1.4.2.10-1jpp

* Thu Nov 17 2005 Fernando Nasser <fnasser@redhat.com> 0:3.0.1-1jpp_4rh
- Use generic javamail alternative
- JMX spec version implemented is 1.2.1

* Wed Nov 16 2005 Fernando Nasser <fnasser@redhat.com> 0:3.0.1-1jpp_3rh
- New 6-digit alternative priority

* Fri Apr 22 2005 Fernando Nasser <fnasser@redhat.com> 0:3.0.1-1jpp_2rh
- Add patch for "patch for java.naming.corba.orb"
- Build without POA

* Fri Apr 22 2005 Fernando Nasser <fnasser@redhat.com> 0:3.0.1-1jpp_1rh
- Merge with upstream for upgrade

* Fri Apr 22 2005 Fernando Nasser <fnasser@redhat.com> 0:3.0.1-1jpp
- Upgrade to 3.0.1

* Wed Apr 20 2005 Fernando Nasser <fnasser@redhat.com> 0:2.1.0-1jpp
- Upgrade to 2.1.0
- Do not build caucho part because of version incompatibilities

* Tue Mar 08 2005 Ralph Apel <r.apel at r-apel.de> 0:2.0.1-3jpp
- Drop spurious Requires: junit

* Wed Oct 27 2004 Fernando Nasser <fnasser@redhat.com> 0:2.0.1-2jpp_1rh
- Merge with upstream for upgrade to 2.0.1
- Correctly specify CatalogManager.properties as a source file
- Deactivate jython- and jetty-related classes
- Disable unit tests, therefore NOT BuildReq xmlunit
- Disable compliance test, therefore NOT BuildReq jmx, jmxremote

* Fri Oct 1 2004 Andrew Overholt <overholt@redhat.com> 1:1.1.1-4jpp_4rh
- add coreutils BuildRequires

* Fri Sep 24 2004 Ralph Apel <r.apel at r-apel.de> 0:2.0.1-2jpp
- Require xml-commons (jpackage), not xml-common (linux)
- Activate jython- and jetty-related classes
- Activate unit tests, therefore BuildReq xmlunit
- Include compliance test, therefore BuildReq jmx, jmxremote
- Define essential runtime requires
- Use security manager and relaxed policy

* Fri Jun 25 2004 Aizaz Ahmed <aahmed@redhat.com> 1:2.0.1-1jpp
- Updated to use mx4j-2.0.1
- Rebuilt with Ant 1.6.2

* Wed Mar 31 2004 Frank Ch. Eigler <fche@redhat.com> 1:1.1.1-4jpp_3rh
- bump up epoch for RHUG upgrading

* Fri Mar 26 2004 Frank Ch. Eigler <fche@redhat.com> 0:1.1.1-4jpp_2rh
- add RHUG upgrade cleanup

* Thu Mar 11 2004 Frank Ch. Eigler <fche@redhat.com: 0:1.1.1-4jpp_1rh
- RH vacuuming
- added mx4j-javaxssl.patch to use javax.net.* instead of com.sun.net.*

* Mon Mar 24 2003 Nicolas Mailhot <Nicolas.Mailhot (at) JPackage.org> 1.1.1-4jpp
- jmxri alternative

* Mon Mar 24 2003 Nicolas Mailhot <Nicolas.Mailhot (at) JPackage.org> 1.1.1-3jpp
- use own dir
- For jpackage-utils 1.5

* Thu Feb 20 2003 Henri Gomez <hgomez@users.sourceforge.net> 1.1.1-1jpp
- mx4j 1.1.1
- grabed from CVS TAG MX4J_1_1_1

* Wed Sep 18 2002 Henri Gomez <hgomez@users.sourceforge.net> 1.1-3jpp
- added missing xsl/jython resources in mx4j-tools.jar
- correct the build.xml to have correct contents for mx4.jar and mx4j-tools.jar

* Tue Jul 02 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 1.1-2jpp
- bzipped additional sources
- section macro
- ant already requires jaxp_parser
- fixed source perms
- fixed compilation with jsse and javamail
- buildrequires jsse >= 1.0.2-6jpp
- buildrequires javamail >= 1.2-5jpp

* Mon Jun 10 2002 Henri Gomez <hgomez@users.sourceforge.net> 1.1-1jpp
- mx4j 1.1 
- set correct jpackage tags
- add provide jmxri

* Mon Mar 04 2002 Henri Gomez <hgomez@users.sourceforge.net> 1.0b3-1jpp
- mx4j 1.0b3 (previous name was openjmx)

* Fri Jan 18 2002 Henri Gomez <hgomez@users.sourceforge.net> 1.0b1-1jpp
- first JPackage release


